applications/patient_registration/urls.py
from django.urls import path

from .views.patient_registration_view import PatientRegistrationCreate, PatientRegistrationDetails, PatientRegistrationList, PatientRegistrationListJson, PatientRegistrationUpdate, PatientRegistrationDelete # call the view classes here

app_name = "patients"
urlpatterns = [
    path('register/', PatientRegistrationCreate.as_view(), name='register'),
    path('update/', PatientRegistrationUpdate.as_view(), name='update'),
    path('details/', PatientRegistrationDetails.as_view(), name='details'),
    path('list/', PatientRegistrationList.as_view(), name='list'),
    path('datalist/', PatientRegistrationListJson.as_view(), name='datalist'),
    path('delete/', PatientRegistrationDelete.as_view(), name='delete'),
]

pathotrack/urls.py
from django.contrib import admin
from django.urls import include,path
import tinymce.urls
from django.conf.urls.static import static # new
from . import settings

 

urlpatterns = [
    path('admin/', admin.site.urls),
    path('patients/', include('applications.patient_registration.urls', namespace='patients')), #every app should be added as `applications.<app name>.urls`
    path('users/', include('applications.users.urls', namespace='users')), 
    path('', include('applications.users.urls', namespace='users')), 
    path('reports/general/', include('applications.general_report.urls', namespace='general-reports')),
    path('reports/cap/', include('applications.cap_report.urls', namespace='cap-reports')),
    path('reports/consolidated/', include('applications.consolidated_report.urls', namespace='consolidated-reports')),
    path('tinymce/', include('tinymce.urls')),
]


if settings.DEBUG: # new
    urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

applications/patient_registration/models/patient_registration_model.py
from django.db import models
from django.utils import timezone
from django.urls import reverse



class State(models.Model):
    value = models.CharField(max_length=200)

    def __str__(self):
        return self.value


class District(models.Model):
    value = models.CharField(max_length=200)

    def __str__(self):
        return self.value


class PatientRegistration(models.Model):

    class Meta:
        db_table = 'patient_details'

    TITLE = [('M','Mr'),('F','Ms'),('B','Baby of'),('D','Dr')]
    GENDER = [('M','Male'),('F','Female'),('O','Other')]
    patient_title = models.CharField('Title', max_length=1, choices=TITLE, default='F', null=True)
    patient_name = models.CharField('Name', max_length=255, null=True, blank=True)
    patient_id = models.CharField('UID', max_length=255, null=True, blank=True, editable=False)
    patient_sex = models.CharField('Sex', max_length=1, choices=GENDER, default='M', null=True)
    patient_dob = models.DateField('Date of birth', null=True, blank=True)
    patient_age = models.SmallIntegerField('Age', null=True, blank=True)
    patient_reg_date = models.DateTimeField('Registration date', auto_now=True, null=True, blank=True)
    patient_address1 = models.CharField('Address line 1', max_length=255, null=True, blank=True)
    patient_address2 = models.CharField('Address line 2', max_length=255, null=True, blank=True)
    patient_city = models.CharField('City', max_length=255, null=True, blank=True)
    patient_district = models.ForeignKey(District, verbose_name="District", on_delete=models.CASCADE, null=True, blank=True)
    patient_state = models.ForeignKey(State, verbose_name="State", on_delete=models.CASCADE, default=12, null=True, blank=True)
    patient_phone = models.BigIntegerField('Phone number', null=True, blank=True)
    patient_phone2 = models.BigIntegerField('Phone number (2)', null=True, blank=True)
    patient_email = models.EmailField('Email', null=True, blank=True)

    def get_fields(self):
        return [(field.verbose_name, field.value_from_object(self)) for field in self.__class__._meta.fields]

applications/patient_registration/views/patient_registration_view.py
from django.views.generic import CreateView, DetailView, ListView, UpdateView, DeleteView, TemplateView
from applications.patient_registration.models.patient_registration_model import PatientRegistration
from applications.general_report.models.general_report_model import StartDiagnosis # For getting a list of reports under a patient_id
from django.shortcuts import redirect, get_object_or_404
from django.http import HttpResponseForbidden
from django_datatables_view.base_datatable_view import BaseDatatableView
from random import randrange
from django.urls import reverse_lazy
from uuid import uuid4
from django.utils.html import format_html
from django.middleware import csrf
from utils.mixins import SessionManagementMixin
from django.contrib import messages

# Class to create patient entry using CreateView
class PatientRegistrationCreate(SessionManagementMixin, CreateView):
    model = PatientRegistration
    template_name = "patient_registration_form.html"
    fields = "__all__"

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        return context

    def form_valid(self, form):
        patient_id = str(uuid4())
        form.instance.patient_id = patient_id
        form.save()
        messages.success(self.request, 'Patient registered successfully!')
        return redirect('patients:list')


# Patient list view datatable
class PatientRegistrationListJson(BaseDatatableView):
    model = PatientRegistration # [FIXME] all the data is not required
    columns = ['slno','patient_name','patient_age','patient_sex','patient_phone','patient_reg_date','patient_city','actions']

    def render_column(self, row, column):
        if column == 'actions':
            csrf_token = csrf.get_token(self.request)
            return format_html('<form method="post"><input type="hidden" name="csrfmiddlewaretoken" value="{}"><input type="hidden" name="pat_id" value="{}"><button class="btn btn-sm btn-success" type="submit" name="submit" value="view"><svg xmlns="http://www.w3.org/2000/svg" class="icon icon-tabler icon-tabler-eye" width="44" height="44" viewBox="0 0 24 24" stroke-width="1.5" stroke="currentColor" fill="none" stroke-linecap="round" stroke-linejoin="round"><path stroke="none" d="M0 0h24v24H0z"/><circle cx="12" cy="12" r="2" /><path d="M2 12l1.5 2a11 11 0 0 0 17 0l1.5 -2" /><path d="M2 12l1.5 -2a11 11 0 0 1 17 0l1.5 2" /></svg>View</button>  <button class="btn btn-sm btn-warning" type="submit" name="submit" value="edit"><svg xmlns="http://www.w3.org/2000/svg" class="icon icon-tabler icon-tabler-edit" width="44" height="44" viewBox="0 0 24 24" stroke-width="1.5" stroke="currentColor" fill="none" stroke-linecap="round" stroke-linejoin="round"><path stroke="none" d="M0 0h24v24H0z"/><path d="M9 7 h-3a2 2 0 0 0 -2 2v9a2 2 0 0 0 2 2h9a2 2 0 0 0 2 -2v-3" /><path d="M9 15h3l8.5 -8.5a1.5 1.5 0 0 0 -3 -3l-8.5 8.5v3" /><line x1="16" y1="5" x2="19" y2="8" /></svg>Edit</button>  <button class="btn btn-sm btn-danger" type="submit" name="submit" value="delete"><svg xmlns="http://www.w3.org/2000/svg" class="icon icon-tabler icon-tabler-trash" width="44" height="44" viewBox="0 0 24 24" stroke-width="1.5" stroke="currentColor" fill="none" stroke-linecap="round" stroke-linejoin="round"><path stroke="none" d="M0 0h24v24H0z"/><line x1="4" y1="7" x2="20" y2="7" /><line x1="10" y1="11" x2="10" y2="17" /><line x1="14" y1="11" x2="14" y2="17" /><path d="M5 7l1 12a2 2 0 0 0 2 2h8a2 2 0 0 0 2 -2l1 -12" /><path d="M9 7v-3a1 1 0 0 1 1 -1h4a1 1 0 0 1 1 1v3" /></svg>Delete</button></form>',csrf_token,row.id)
        elif column == 'patient_reg_date':
            return format_html('{}',row.patient_reg_date.strftime("%Y-%m-%d"))
        elif column == 'slno':
            return format_html('1')
        else:
            return super(PatientRegistrationListJson, self).render_column(row, column)


class PatientRegistrationList(SessionManagementMixin, TemplateView):
    template_name = 'patient_registration_list.html'

    def post(self, request):  # Taking post request contents from the template
        if(request.POST.get("submit") == "add"):
            return redirect('patients:register')

        patient_id = request.POST.get("pat_id")
        print(request.POST)
        self.request.session['patient_id'] = patient_id # Saving to session

        if(request.POST.get("submit") == "view"):
            return redirect('patients:details')
        elif(request.POST.get("submit") == "edit"):
            return redirect('patients:update')
        elif(request.POST.get("submit") == "delete"):
            return redirect('patients:delete')
        else:
            del self.request.session['patient_id']
            return HttpResponseForbidden() # improve this later by adding invalid request template[FIX_ME]


# Patient detail view
class PatientRegistrationDetails(SessionManagementMixin, DetailView):
    model = PatientRegistration
    context_object_name = 'patient'
    template_name = "patient_registration_details.html"
    session_vars = ['patient_id']

    def get_object(self): # to get object with pk with patient id
        return get_object_or_404(self.model, pk=self.request.session['patient_id'])

    def get_context_data(self, **kwargs): # appending report lists to patient
        context = super().get_context_data(**kwargs)
        context['reports'] = StartDiagnosis.objects.order_by('patient_enter_date').reverse().values('patient_id_id', 'pathology_id', 'report_status', 'patient_enter_date', 'patient_sample', 'acc_no').filter(patient_id_id = self.request.session['patient_id'] )

        # context['general_reports'] = GeneralReport.all().filter(patient_id = self.patient_id) # adding general reports with current patient_id to the context
        return context

    def post(self, request):  # Taking post request contents from the template
        # if 'general_report_id' in request.POST: # if there is a general_report_id in the post request, it is to report details screen
        #     self.request.session['general_report_id'] = request.POST.get('report_id')
        #     return redirect('report-details')

        # else:

        patient_id = request.POST.get("patient_id")
        acc_no = request.POST.get("acc_no")
        self.request.session['patient_id'] = patient_id

        if(request.POST.get("submit") == "report"):
            patient = PatientRegistration.objects.get(pk = patient_id)
            self.request.session['patient_name'] = patient.patient_name
            self.request.session['patient_age'] = patient.patient_age
            self.request.session['patient_sex'] = patient.patient_sex
            return redirect('general-reports:start-diagnosis')

        if(request.POST.get("submit") == "list"):
            return redirect('patients:list')
        if(request.POST.get("submit") == "delete"):
            return redirect('patients:delete')
        if(request.POST.get("submit") == "edit"):
            return redirect('patients:update')

        if(request.POST.get("submit") == "report-view"):
            self.request.session['patient_id'] = patient_id
            self.request.session['acc_no'] = acc_no
            return redirect('consolidated-reports:details')

        del self.request.session['patient_id']
        return HttpResponseForbidden() # improve this later by adding invalid request template[FIX_ME]


# Class to update patient entry using update view
class PatientRegistrationUpdate(SessionManagementMixin, UpdateView):
    model = PatientRegistration
    template_name = "patient_registration_form.html"
    fields = "__all__"
    session_vars = ['patient_id']

    def get_object(self):
        return get_object_or_404(self.model, pk=self.request.session['patient_id'])

    def form_valid(self, form):
        report = form.save()
        patient_id = form.instance.id
        self.request.session['patient_id'] = patient_id
        return redirect('patients:details')


class PatientRegistrationDelete(SessionManagementMixin, DeleteView):
    model = PatientRegistration
    template_name = "patient_registration_delete.html"
    context_object_name = 'patient'
    success_url = reverse_lazy('patients:list')
    session_vars =  ['patient_id']

    def get_object(self):
        return get_object_or_404(self.model, pk=self.request.session['patient_id'])

    def post(self, request, *args, **kwargs):
        patient_id = request.POST.get("patient_id")
        self.request.session['patient_id'] = patient_id

        if(request.POST.get("submit") == "details"):
            return redirect('patients:details')
        if(request.POST.get("submit") == "delete"):
            return super().post(request, *args, **kwargs)

        del self.request.session['patient_id']
        return HttpResponseForbidden() # improve this later by adding invalid request template[FIX_ME]

applications/patient_registration/templates/patient_registration_delete.html
{% extends 'pathotrack/layout/base.html' %}

{% block content %}

<div class="row">
  <div class="col-12">
    <div class="card">
      <div class="card-header">
        <h4 class="card-title">Delete Patient</h4>
      </div>

      <div class="card-body">
        <p>Are you sure you want to delete the entry of "{{ patient.patient_name }}" ?</p>
      </div>

      <div class="card-footer">
        <form method="POST">
          {% csrf_token %}
          <input type="hidden" name="patient_id" value="{{ patient.id }}">
          <span class="d-flex">
            <button class="btn btn-secondary m-1" type="submit" name="submit" value="details">
              <svg xmlns="http://www.w3.org/2000/svg" class="icon icon-tabler icon-tabler-circle-x" width="44" height="44" viewBox="0 0 24 24" stroke-width="1.5" stroke="currentColor" fill="none" stroke-linecap="round" stroke-linejoin="round">
                <path stroke="none" d="M0 0h24v24H0z"/>
                <circle cx="12" cy="12" r="9" />
                <path d="M10 10l4 4m0 -4l-4 4" />
              </svg>
              Cancel
            </button>

            <button class="btn btn-danger m-1 ml-auto" type="submit" name="submit" value="delete">
              <svg xmlns="http://www.w3.org/2000/svg" class="icon icon-tabler icon-tabler-trash" width="44" height="44" viewBox="0 0 24 24" stroke-width="1.5" stroke="currentColor" fill="none" stroke-linecap="round" stroke-linejoin="round">
                <path stroke="none" d="M0 0h24v24H0z"/>
                <line x1="4" y1="7" x2="20" y2="7" />
                <line x1="10" y1="11" x2="10" y2="17" />
                <line x1="14" y1="11" x2="14" y2="17" />
                <path d="M5 7l1 12a2 2 0 0 0 2 2h8a2 2 0 0 0 2 -2l1 -12" />
                <path d="M9 7v-3a1 1 0 0 1 1 -1h4a1 1 0 0 1 1 1v3" />
              </svg>
              Yes, Delete
            </button>
          </span>
        </form>

      </div>
    </div>
  </div>
</div>

{% endblock content %}

applications/patient_registration/templates/patient_registration_details.html
{% extends 'pathotrack/layout/base.html' %}

{% block top-menu %}{% endblock top-menu %}

{% block content %}

<div class="box">
  <div class="card">
    <div class="card-header">
      <h3 class="card-title">Patient Details</h3>
    </div>

    <div class="table-responsive">
      <table class="table table-striped table-vcenter card-table">
        <tbody>
          {% for key,value in patient.get_fields %}
          {% if key != 'ID' and key != 'Title' %}
          <tr>
            <th socpe="row">
              {{ key }}
            </th>
            <td>
                {% if key == 'Name' %}
                {{ patient.get_patient_title_display }}. {{ value|capfirst }}

                {% elif key == 'Date of birth' or key == 'Registration date' %}
                {{ value|date:"M d, Y" }} <small>({{ value|date:"d/m/Y" }})</small>

                {% elif key == 'District' %}
                {{ patient.patient_district }}

                {% elif key == 'State' %}
                {{ patient.patient_state }}

                {% elif key == 'Email' %}
                {{ value }}

                {% else %}
                {{ value|capfirst }}
            </td>
            {% endif %}
          </tr>
          {% endif %}
          {% endfor %}
        </tbody>
      </table>
    </div>

    <div class="card-footer">
      <form method="POST">
        {% csrf_token %}
        <input type="hidden" name="patient_id" value={{ patient.id }}>

        <span class="d-flex">
          <button class="btn btn-secondary m-1" type="submit" name="submit" value="list">
            <svg xmlns="http://www.w3.org/2000/svg" class="icon icon-tabler icon-tabler-arrow-left-circle" width="44" height="44" viewBox="0 0 24 24" stroke-width="1.5" stroke="currentColor" fill="none" stroke-linecap="round" stroke-linejoin="round">
              <path stroke="none" d="M0 0h24v24H0z"/>
              <circle cx="12" cy="12" r="9" />
              <line x1="8" y1="12" x2="16" y2="12" />
              <line x1="8" y1="12" x2="12" y2="16" />
              <line x1="8" y1="12" x2="12" y2="8" />
            </svg>
            Back
          </button>

          <button class="btn btn-danger m-1 ml-auto" type="submit" name="submit" value="delete">
            <svg xmlns="http://www.w3.org/2000/svg" class="icon icon-tabler icon-tabler-trash" width="44" height="44" viewBox="0 0 24 24" stroke-width="1.5" stroke="currentColor" fill="none" stroke-linecap="round" stroke-linejoin="round">
              <path stroke="none" d="M0 0h24v24H0z"/>
              <line x1="4" y1="7" x2="20" y2="7" />
              <line x1="10" y1="11" x2="10" y2="17" />
              <line x1="14" y1="11" x2="14" y2="17" />
              <path d="M5 7l1 12a2 2 0 0 0 2 2h8a2 2 0 0 0 2 -2l1 -12" />
              <path d="M9 7v-3a1 1 0 0 1 1 -1h4a1 1 0 0 1 1 1v3" />
            </svg>
            Delete
          </button>

          <button class="btn btn-warning m-1" type="submit" name="submit" value="edit">
            <svg xmlns="http://www.w3.org/2000/svg" class="icon icon-tabler icon-tabler-edit" width="44" height="44" viewBox="0 0 24 24" stroke-width="1.5" stroke="currentColor" fill="none" stroke-linecap="round" stroke-linejoin="round">
              <path stroke="none" d="M0 0h24v24H0z"/>
              <path d="M9 7 h-3a2 2 0 0 0 -2 2v9a2 2 0 0 0 2 2h9a2 2 0 0 0 2 -2v-3" />
              <path d="M9 15h3l8.5 -8.5a1.5 1.5 0 0 0 -3 -3l-8.5 8.5v3" />
              <line x1="16" y1="5" x2="19" y2="8" />
            </svg>
            Edit
          </button>
        </span>
      </form>
    </div>
  </div>

  <div class="card">
    <div class="card-header">
      <h2>Reports</h2>
      <div class="ml-auto">
        <form method="POST">
          {% csrf_token %}
          <input type="hidden" name="patient_id" value="{{ patient.id }}">
          <button class="btn btn-primary" type="submit" name="submit" value="report">
            <svg xmlns="http://www.w3.org/2000/svg" class="icon icon-tabler icon-tabler-circle-plus" width="44" height="44" viewBox="0 0 24 24" stroke-width="1.5" stroke="currentColor" fill="none" stroke-linecap="round" stroke-linejoin="round">
              <path stroke="none" d="M0 0h24v24H0z"/>
              <circle cx="12" cy="12" r="9" />
              <line x1="9" y1="12" x2="15" y2="12" />
              <line x1="12" y1="9" x2="12" y2="15" />
            </svg>
            Add Report
          </button>
        </form>
      </div>
    </div>
    <div class="card-body">
        <div class="table-responsive">
            <table class="table table-vcenter card-table">
                <thead>
                    <tr>
                        <th>Sl No</th>
                        <th>Pathology ID</th>
                        <th>Entry Date</th>
                        <th>Sample</th>
                        <th>Accession No</th>
                        <th>Status</th>
                        <th>Actions</th>
                    </tr>
                </thead>

                <tbody>
                    {% for report in reports %}
                    <tr>
                        <td>{{ forloop.counter }}</td>
                        <td>{{ report.pathology_id }}</td>
                        <td>{{ report.patient_enter_date }}</td>
                        <td>{{ report.patient_sample }}</td>
                        <td>{{ report.acc_no }}</td>
                        <td><span class="badge {{ report.report_status }} ml-2 px-2">{{ report.report_status }}</span></td>

                        <td width="240">
                          <form method="POST">
                            {% csrf_token %}
                            <input type="hidden" name="patient_id" value="{{ patient.id }}">
                            <input type="hidden" name="acc_no" value={{ report.acc_no }}>
                                <button class="btn btn-sm btn-success" type="submit" name="submit" value="report-view">
                                    <svg xmlns="http://www.w3.org/2000/svg" class="icon icon-tabler icon-tabler-eye" width="44" height="44" viewBox="0 0 24 24" stroke-width="1.5" stroke="currentColor" fill="none" stroke-linecap="round" stroke-linejoin="round">
                                        <path stroke="none" d="M0 0h24v24H0z"/>
                                        <circle cx="12" cy="12" r="2" />
                                        <path d="M2 12l1.5 2a11 11 0 0 0 17 0l1.5 -2" />
                                        <path d="M2 12l1.5 -2a11 11 0 0 1 17 0l1.5 2" />
                                    </svg>
                                    View
                                </button>

                                <!--
                                     <button class="btn btn-sm btn-warning" type="submit" name="submit" value="report-edit">
                                     <svg xmlns="http://www.w3.org/2000/svg" class="icon icon-tabler icon-tabler-edit" width="44" height="44" viewBox="0 0 24 24" stroke-width="1.5" stroke="currentColor" fill="none" stroke-linecap="round" stroke-linejoin="round">
                                     <path stroke="none" d="M0 0h24v24H0z"/>
                                     <path d="M9 7 h-3a2 2 0 0 0 -2 2v9a2 2 0 0 0 2 2h9a2 2 0 0 0 2 -2v-3" />
                                     <path d="M9 15h3l8.5 -8.5a1.5 1.5 0 0 0 -3 -3l-8.5 8.5v3" />
                                     <line x1="16" y1="5" x2="19" y2="8" />
                                     </svg>
                                     Edit
                                     </button>

                                     <button class="btn btn-sm btn-danger" type="submit" name="submit" value="report-delete">
                                     <svg xmlns="http://www.w3.org/2000/svg" class="icon icon-tabler icon-tabler-trash" width="44" height="44" viewBox="0 0 24 24" stroke-width="1.5" stroke="currentColor" fill="none" stroke-linecap="round" stroke-linejoin="round">
                                     <path stroke="none" d="M0 0h24v24H0z"/>
                                     <line x1="4" y1="7" x2="20" y2="7" />
                                     <line x1="10" y1="11" x2="10" y2="17" />
                                     <line x1="14" y1="11" x2="14" y2="17" />
                                     <path d="M5 7l1 12a2 2 0 0 0 2 2h8a2 2 0 0 0 2 -2l1 -12" />
                                     <path d="M9 7v-3a1 1 0 0 1 1 -1h4a1 1 0 0 1 1 1v3" />
                                     </svg>
                                     Delete
                                     </button>
                                -->

                          </form>
                        </td>
                    </tr>
                    {% endfor %}
                </tbody>
            </table>
        </div>

    </div>
  </div>
</div>
<script>
 $(document).ready(function(){
     $('.draft').removeClass('draft').addClass('bg-pink');
     $('.wip').removeClass('wip').addClass('bg-orange');
     $('.submitted').removeClass('submitted').addClass('bg-blue');
 });
</script>

{% endblock content %}

applications/patient_registration/templates/patient_registration_list.html
{% extends 'pathotrack/layout/base.html' %}

{% block content %}

<div class="box">
  <div class="card">
    <div class="card-header">
      <h3 class="card-title">Patients List</h3>
      <div class="ml-auto">
        <form method="POST">
          {% csrf_token %}
          <button class="btn btn-primary" type="submit" name="submit" value="add">
              <svg xmlns="http://www.w3.org/2000/svg" class="icon icon-tabler icon-tabler-circle-plus" width="44" height="44" viewBox="0 0 24 24" stroke-width="1.5" stroke="currentColor" fill="none" stroke-linecap="round" stroke-linejoin="round">
                  <path stroke="none" d="M0 0h24v24H0z"/>
                  <circle cx="12" cy="12" r="9" />
                  <line x1="9" y1="12" x2="15" y2="12" />
                  <line x1="12" y1="9" x2="12" y2="15" />
              </svg>
              Add Patient
          </button>
        </form>
      </div>
    </div>
    <div class="card-body border-bottom py-3">
      <div class="row">
        <div class="col-md-3 mb-2 text-muted form-group">
            Name:
            <input type="text" id="name" class="form-control mt-1">
        </div>
        <div class="col-md-3 mb-2 text-muted form-group">
            Phone No:
            <input type="text" id="phone" class="form-control mt-1">
        </div>
        <div class="col-md-3 mb-2 text-muted form-group">
            Date:
            <div class="input-icon">
                <input id="calendar-time" type="date" name="{{ form.patient_dob.name }}" value="{{ form.patient_dob.value|date:"Y-m-d" }}" class="form-control" placeholder="Select a date" />
                <span class="input-icon-addon"><svg xmlns="http://www.w3.org/2000/svg" class="icon" width="24" height="24" viewBox="0 0 24 24" stroke-width="2" stroke="currentColor" fill="none" stroke-linecap="round" stroke-linejoin="round"><path stroke="none" d="M0 0h24v24H0z"/><rect x="4" y="5" width="16" height="16" rx="2" /><line x1="16" y1="3" x2="16" y2="7" /><line x1="8" y1="3" x2="8" y2="7" /><line x1="4" y1="11" x2="20" y2="11" /><line x1="11" y1="15" x2="12" y2="15" /><line x1="12" y1="15" x2="12" y2="18" /></svg>
                </span>
            </div>
        </div>
        <div class="col-md-3 mb-2 text-muted form-group">
            Clear Fields:
            <button id="clearfield" class="form-control mt-1 btn btn-primary" type="submit" name="submit" value="view">
                <svg xmlns="http://www.w3.org/2000/svg" class="icon icon-md" width="24" height="24" viewBox="0 0 24 24" stroke-width="2" stroke="currentColor" fill="none" stroke-linecap="round" stroke-linejoin="round"><path stroke="none" d="M0 0h24v24H0z"></path><path d="M19 19h-11l-4 -4a1 1 0 0 1 0 -1.41l10 -10a1 1 0 0 1 1.41 0l5 5a1 1 0 0 1 0 1.41l-9 9"></path><path d="M18 12.3l-6.3 -6.3"></path></svg>
                Clear
            </button>

        </div>
    </div>
    </div>
    <div class="table-responsive p-1">
            <table id="patient_table" class="table table-striped text-center table-bordered">
          <thead>
              <tr>
                  <th>Sl No</th>
                  <th>Name</th>
                  <th>Age</th>
                  <th>Sex</th>
                  <th>Phone No</th>
                  <th>Entry Date</th>
                  <th>City</th>
                  <th>Actions</th>
              </tr>
          </thead>
      </table>
  </div>
</div>
</div>
<!-- {% load static %}
     <script src="{% static 'datatable.js' %}"></script> -->

<script>

 $(document).ready(function() {
     var table = $('#patient_table').DataTable({
         "serverSide": true,
         "ajax": "{% url "patients:datalist" %}",
         //   "lengthMenu": [[10, 20, 50], [10, 20, 50]],
         "lengthChange": false,
         "searching": true,
         "sDom": 't<"float-right d-inline-flex p-2"p>',
         "columnDefs": [
             {"searchable": false,
              "orderable": false,
              "targets": 0
             } ],
         "order": [[ 1, 'asc' ]]

     });


     table.on( 'order.dt search.dt', function () {
         table.column(0, {search:'applied', order:'applied'}).nodes().each( function (cell, i)
             {
                 cell.innerHTML = i+1;
             } );
     } ).draw();



     $('#name').keyup(function(){
         table.column(1).search($(this).val()).draw();
     });

     $('#phone').keyup(function(){
         table.column(4).search($(this).val()).draw();
     });

     $('#clearfield').click(function(){
         $('#name').val('');
         $('#phone').val('');
         $('#calendar-time').val('');
         table.column(1).search('').draw();
         table.column(5).search('').draw();
         table.column(4).search('').draw();

     }); 

  	 flatpickr(document.getElementById('calendar-time'), {
         defaultDate: $('#calendar-time').val(),
         onChange: function(selectedDates, dateStr, instance) {
             $('#calendar-time').val(dateStr);
             console.log($('#calendar-time').val());
             console.log(dateStr);
             table.column(5).search(dateStr).draw();

         },

     });
 });


</script>

{% endblock content %}